diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/he/he-frame-exchange-manager.cc ns-3.35/src/wifi/model/he/he-frame-exchange-manager.cc
--- ns-3.34/src/wifi/model/he/he-frame-exchange-manager.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/he/he-frame-exchange-manager.cc	2021-10-01 13:26:48.000000000 -0700
@@ -593,9 +593,6 @@
   for (const auto& psdu : psduMap)
     {
       NotifyTxToEdca (psdu.second);
-
-      // the PSDU is about to be transmitted, we can now dequeue the MPDUs
-      DequeuePsdu (psdu.second);
     }
   if (psduMap.size () > 1 || psduMap.begin ()->second->IsAggregate () || psduMap.begin ()->second->IsSingle ())
     {
@@ -1194,7 +1191,7 @@
       // otherwise, check if a suitable data frame is available
       if ((mpdu = edca->PeekNextMpdu (tid, hdr.GetAddr2 ())) != 0)
         {
-          WifiMacQueueItem::QueueIteratorPair queueIt;
+          WifiMacQueueItem::ConstIterator queueIt;
           Ptr<WifiMacQueueItem> item = edca->GetNextMpdu (mpdu, txParams, ppduDuration, false, queueIt);
 
           if (item != 0)
@@ -1428,8 +1425,10 @@
           CtrlBAckResponseHeader blockAck;
           mpdu->GetPacket ()->PeekHeader (blockAck);
           uint8_t tid = blockAck.GetTidInfo ();
-          GetBaManager (tid)->NotifyGotBlockAck (blockAck, hdr.GetAddr2 (), {tid}, rxSignalInfo.snr,
-                                                 tag.Get (), m_txParams.m_txVector);
+          std::pair<uint16_t,uint16_t> ret = GetBaManager (tid)->NotifyGotBlockAck (blockAck, hdr.GetAddr2 (),
+                                                                                    {tid});
+          m_mac->GetWifiRemoteStationManager ()->ReportAmpduTxStatus (hdr.GetAddr2 (), ret.first, ret.second,
+                                                                      rxSignalInfo.snr, tag.Get (), m_txParams.m_txVector);
 
           // remove the sender from the set of stations that are expected to send a BlockAck
           if (m_staExpectTbPpduFrom.erase (sender) == 0)
@@ -1497,9 +1496,27 @@
                       tid = *tids.begin ();
                     }
 
-                  GetBaManager (tid)->NotifyGotBlockAck (blockAck, hdr.GetAddr2 (), {tid},
-                                                         rxSignalInfo.snr, tag.Get (staId),
-                                                         m_txParams.m_txVector, index);
+                  std::pair<uint16_t,uint16_t> ret = GetBaManager (tid)->NotifyGotBlockAck (blockAck,
+                                                                                            hdr.GetAddr2 (),
+                                                                                            {tid}, index);
+                  m_mac->GetWifiRemoteStationManager ()->ReportAmpduTxStatus (hdr.GetAddr2 (), ret.first,
+                                                                              ret.second, rxSignalInfo.snr,
+                                                                              tag.Get (staId),  m_txParams.m_txVector);
+                }
+
+              if (m_psduMap.at (staId)->GetHeader (0).IsQosData ()
+                  && (blockAck.GetAckType (index)  // Ack or All-ack context
+                      || std::any_of (blockAck.GetBitmap (index).begin (),
+                                      blockAck.GetBitmap (index).end (),
+                                      [](uint8_t b) { return b != 0; })))
+                {
+                  NS_ASSERT (m_psduMap.at (staId)->GetHeader (0).HasData ());
+                  NS_ASSERT (m_psduMap.at (staId)->GetHeader (0).GetQosTid () == tid);
+                  // the station has received a response from the AP for the HE TB PPDU
+                  // transmitted in response to a Basic Trigger Frame and at least one
+                  // MPDU was acknowledged. Therefore, it needs to update the access
+                  // parameters if it received an MU EDCA Parameter Set element.
+                  m_mac->GetQosTxop (tid)->StartMuEdcaTimerNow ();
                 }
             }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/he/he-phy.cc ns-3.35/src/wifi/model/he/he-phy.cc
--- ns-3.34/src/wifi/model/he/he-phy.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/he/he-phy.cc	2021-10-01 13:26:48.000000000 -0700
@@ -106,8 +106,9 @@
   switch (field)
     {
       case WIFI_PPDU_FIELD_TRAINING: //consider SIG-A (SIG-B) mode for training for the time being for SU/ER-SU/TB (MU) (useful for InterferenceHelper)
-        if (txVector.GetPreambleType () == WIFI_PREAMBLE_HE_MU)
+        if (txVector.IsDlMu ())
           {
+            NS_ASSERT (txVector.GetModulationClass () == WIFI_MOD_CLASS_HE);
             //Training comes after SIG-B
             return GetSigBMode (txVector);
           }
@@ -130,7 +131,7 @@
 WifiMode
 HePhy::GetSigBMode (const WifiTxVector& txVector) const
 {
-  NS_ABORT_MSG_IF (txVector.GetPreambleType () != WIFI_PREAMBLE_HE_MU, "HE-SIG-B only available for HE MU");
+  NS_ABORT_MSG_IF (!txVector.IsDlMu () || (txVector.GetModulationClass () != WIFI_MOD_CLASS_HE), "HE-SIG-B only available for HE MU");
   /**
    * Get smallest HE MCS index among station's allocations and use the
    * VHT version of the index. This enables to have 800 ns GI, 52 data
@@ -177,7 +178,16 @@
                             uint8_t nDataLtf, uint8_t nExtensionLtf /* = 0 */) const
 {
   Time ltfDuration = MicroSeconds (8); //TODO extract from TxVector when available
-  Time stfDuration = (txVector.GetPreambleType () == WIFI_PREAMBLE_HE_TB) ? MicroSeconds (8) : MicroSeconds (4);
+  Time stfDuration;
+  if (txVector.IsUlMu ())
+    {
+      NS_ASSERT (txVector.GetModulationClass () == WIFI_MOD_CLASS_HE);
+      stfDuration = MicroSeconds (8);
+    }
+  else
+    {
+      stfDuration = MicroSeconds (4);
+    }
   NS_ABORT_MSG_IF (nDataLtf > 8, "Unsupported number of LTFs " << +nDataLtf << " for HE");
   NS_ABORT_MSG_IF (nExtensionLtf > 0, "No extension LTFs expected for HE");
   return stfDuration + ltfDuration * nDataLtf; //HE-STF + HE-LTFs
@@ -192,8 +202,9 @@
 Time
 HePhy::GetSigBDuration (const WifiTxVector& txVector) const
 {
-  if (txVector.GetPreambleType () == WIFI_PREAMBLE_HE_MU) //See section 27.3.10.8 of IEEE 802.11ax draft 4.0.
+  if (txVector.IsDlMu ()) //See section 27.3.10.8 of IEEE 802.11ax draft 4.0.
     {
+      NS_ASSERT (txVector.GetModulationClass () == WIFI_MOD_CLASS_HE);
       /*
        * Compute the number of bits used by common field.
        * Assume that compression bit in HE-SIG-A is not set (i.e. not
@@ -262,7 +273,7 @@
 Time
 HePhy::ConvertLSigLengthToHeTbPpduDuration (uint16_t length, const WifiTxVector& txVector, WifiPhyBand band)
 {
-  NS_ABORT_IF (txVector.GetPreambleType () != WIFI_PREAMBLE_HE_TB);
+  NS_ABORT_IF (!txVector.IsUlMu () || (txVector.GetModulationClass () != WIFI_MOD_CLASS_HE));
   Time tSymbol = NanoSeconds (12800 + txVector.GetGuardInterval ());
   Time preambleDuration = WifiPhy::GetStaticPhyEntity (WIFI_MOD_CLASS_HE)->CalculatePhyPreambleAndHeaderDuration (txVector); //this is quite convoluted but only way of keeping the method static
   uint8_t sigExtension = 0;
@@ -281,7 +292,7 @@
 Time
 HePhy::CalculateNonOfdmaDurationForHeTb (const WifiTxVector& txVector) const
 {
-  NS_ABORT_IF (txVector.GetPreambleType () != WIFI_PREAMBLE_HE_TB);
+  NS_ABORT_IF (!txVector.IsUlMu () || (txVector.GetModulationClass () != WIFI_MOD_CLASS_HE));
   Time duration = GetDuration (WIFI_PPDU_FIELD_PREAMBLE, txVector)
     + GetDuration (WIFI_PPDU_FIELD_NON_HT_HEADER, txVector)
     + GetDuration (WIFI_PPDU_FIELD_SIG_A, txVector);
@@ -306,15 +317,22 @@
 HePhy::BuildPpdu (const WifiConstPsduMap & psdus, const WifiTxVector& txVector, Time ppduDuration)
 {
   NS_LOG_FUNCTION (this << psdus << txVector << ppduDuration);
-  HePpdu::TxPsdFlag flag = (txVector.GetPreambleType () == WIFI_PREAMBLE_HE_TB) ?
-    HePpdu::PSD_HE_TB_NON_OFDMA_PORTION :
-    HePpdu::PSD_NON_HE_TB;
+  HePpdu::TxPsdFlag flag;
+  if (txVector.IsUlMu ())
+    {
+      NS_ASSERT (txVector.GetModulationClass () == WIFI_MOD_CLASS_HE);
+      flag = HePpdu::PSD_HE_TB_NON_OFDMA_PORTION;
+    }
+  else
+    {
+      flag = HePpdu::PSD_NON_HE_TB;
+    }
   return Create<HePpdu> (psdus, txVector, ppduDuration, m_wifiPhy->GetPhyBand (),
                          ObtainNextUid (txVector), flag);
 }
 
 void
-HePhy::StartReceivePreamble (Ptr<WifiPpdu> ppdu, RxPowerWattPerChannelBand rxPowersW,
+HePhy::StartReceivePreamble (Ptr<WifiPpdu> ppdu, RxPowerWattPerChannelBand& rxPowersW,
                              Time rxDuration)
 {
   NS_LOG_FUNCTION (this << ppdu << rxDuration);
@@ -322,9 +340,9 @@
   auto hePpdu = DynamicCast<HePpdu> (ppdu);
   NS_ASSERT (hePpdu);
   HePpdu::TxPsdFlag psdFlag = hePpdu->GetTxPsdFlag ();
-  if (txVector.GetPreambleType () == WIFI_PREAMBLE_HE_TB
-      && psdFlag == HePpdu::PSD_HE_TB_OFDMA_PORTION)
+  if (txVector.IsUlMu () && psdFlag == HePpdu::PSD_HE_TB_OFDMA_PORTION)
     {
+      NS_ASSERT (txVector.GetModulationClass () == WIFI_MOD_CLASS_HE);
       if (m_currentHeTbPpduUid == ppdu->GetUid ()
           && GetCurrentEvent () != 0)
         {
@@ -399,7 +417,7 @@
 }
 
 Ptr<Event>
-HePhy::DoGetEvent (Ptr<const WifiPpdu> ppdu, RxPowerWattPerChannelBand rxPowersW)
+HePhy::DoGetEvent (Ptr<const WifiPpdu> ppdu, RxPowerWattPerChannelBand& rxPowersW)
 {
   Ptr<Event> event;
   //We store all incoming preamble events, and a decision is made at the end of the preamble detection window.
@@ -509,16 +527,17 @@
 {
   NS_LOG_FUNCTION (this << *event << status);
   //Notify end of SIG-A (in all cases)
+  WifiTxVector txVector = event->GetTxVector ();
   HeSigAParameters params;
   params.rssiW = GetRxPowerWForPpdu (event);
-  params.bssColor = event->GetTxVector ().GetBssColor ();
+  params.bssColor = txVector.GetBssColor ();
   NotifyEndOfHeSigA (params); //if OBSS_PD CCA_RESET, set power restriction first and wait till field is processed before switching to IDLE
 
   if (status.isSuccess)
     {
       //Check if PPDU is filtered based on the BSS color
       uint8_t myBssColor = GetBssColor ();
-      uint8_t rxBssColor = event->GetTxVector ().GetBssColor ();
+      uint8_t rxBssColor = txVector.GetBssColor ();
       if (myBssColor != 0 && rxBssColor != 0 && myBssColor != rxBssColor)
         {
           NS_LOG_DEBUG ("The BSS color of this PPDU (" << +rxBssColor << ") does not match the device's (" << +myBssColor << "). The PPDU is filtered.");
@@ -526,8 +545,9 @@
         }
 
       Ptr<const WifiPpdu> ppdu = event->GetPpdu ();
-      if (event->GetTxVector ().GetPreambleType () == WIFI_PREAMBLE_HE_TB)
+      if (txVector.IsUlMu ())
         {
+          NS_ASSERT (txVector.GetModulationClass () == WIFI_MOD_CLASS_HE);
           m_currentHeTbPpduUid = ppdu->GetUid (); //to be able to correctly schedule start of OFDMA payload
         }
 
@@ -579,8 +599,9 @@
   uint16_t staId = GetStaId (ppdu);
   WifiMode txMode = txVector.GetMode (staId);
   uint8_t nss = txVector.GetNssMax ();
-  if (txVector.GetPreambleType () == WIFI_PREAMBLE_HE_MU)
+  if (txVector.IsDlMu ())
     {
+      NS_ASSERT (txVector.GetModulationClass () == WIFI_MOD_CLASS_HE);
       for (auto info : txVector.GetHeMuUserInfoMap ())
         {
           if (info.first == staId)
@@ -610,8 +631,9 @@
   NS_LOG_FUNCTION (this << *event);
   const WifiTxVector& txVector = event->GetTxVector ();
   Ptr<const WifiPpdu> ppdu = event->GetPpdu ();
-  if (txVector.GetPreambleType () == WIFI_PREAMBLE_HE_TB)
+  if (txVector.IsUlMu ())
     {
+      NS_ASSERT (txVector.GetModulationClass () == WIFI_MOD_CLASS_HE);
       Ptr<WifiNetDevice> device = DynamicCast<WifiNetDevice> (m_wifiPhy->GetDevice ());
       bool isAp = device != 0 && (DynamicCast<ApWifiMac> (device->GetMac ()) != 0);
       if (!isAp)
@@ -633,15 +655,12 @@
           uint16_t staId = GetStaId (ppdu);
           m_signalNoiseMap.insert ({std::make_pair (ppdu->GetUid (), staId), SignalNoiseDbm ()});
           m_statusPerMpduMap.insert ({std::make_pair (ppdu->GetUid (), staId), std::vector<bool> ()});
-          if (txVector.GetPreambleType () == WIFI_PREAMBLE_HE_TB)
+          //for HE TB PPDUs, ScheduleEndOfMpdus and EndReceive are scheduled by StartReceiveOfdmaPayload
+          NS_ASSERT (isAp);
+          NS_ASSERT (!m_beginOfdmaPayloadRxEvents.empty ());
+          for (auto & beginOfdmaPayloadRxEvent : m_beginOfdmaPayloadRxEvents)
             {
-              //for HE TB PPDUs, ScheduleEndOfMpdus and EndReceive are scheduled by StartReceiveOfdmaPayload
-              NS_ASSERT (isAp);
-              NS_ASSERT (!m_beginOfdmaPayloadRxEvents.empty ());
-              for (auto & beginOfdmaPayloadRxEvent : m_beginOfdmaPayloadRxEvents)
-                {
-                  NS_ASSERT (beginOfdmaPayloadRxEvent.second.IsRunning ());
-                }
+              NS_ASSERT (beginOfdmaPayloadRxEvent.second.IsRunning ());
             }
         }
     }
@@ -685,12 +704,18 @@
 HePhy::StartReceiveOfdmaPayload (Ptr<Event> event)
 {
   Ptr<const WifiPpdu> ppdu = event->GetPpdu ();
-  RxPowerWattPerChannelBand rxPowersW = event->GetRxPowerWPerBand ();
-  //The total RX power corresponds to the maximum over all the bands
-  auto it = std::max_element (rxPowersW.begin (), rxPowersW.end (),
-                              [] (const std::pair<WifiSpectrumBand, double> &p1, const std::pair<WifiSpectrumBand, double> &p2) {
-                                return p1.second < p2.second;
-                              });
+  const RxPowerWattPerChannelBand& rxPowersW = event->GetRxPowerWPerBand ();
+  //The total RX power corresponds to the maximum over all the bands.
+  //Only perform this computation if the result needs to be logged.
+  auto it = rxPowersW.end ();
+  if (g_log.IsEnabled (ns3::LOG_FUNCTION))
+    {
+      it = std::max_element (rxPowersW.begin (), rxPowersW.end (),
+                             [] (const std::pair<WifiSpectrumBand, double> &p1, const std::pair<WifiSpectrumBand, double> &p2) {
+                               return p1.second < p2.second;
+                             });
+
+    }
   NS_LOG_FUNCTION (this << *event << it->second);
   NS_ASSERT (GetCurrentEvent () != 0);
   auto itEvent = m_beginOfdmaPayloadRxEvents.find (GetStaId (ppdu));
@@ -761,7 +786,7 @@
 WifiSpectrumBand
 HePhy::GetNonOfdmaBand (const WifiTxVector& txVector, uint16_t staId) const
 {
-  NS_ASSERT (txVector.GetPreambleType () == WIFI_PREAMBLE_HE_TB);
+  NS_ASSERT (txVector.IsUlMu () && (txVector.GetModulationClass () == WIFI_MOD_CLASS_HE));
   uint16_t channelWidth = txVector.GetChannelWidth ();
   NS_ASSERT (channelWidth <= m_wifiPhy->GetChannelWidth ());
 
@@ -819,8 +844,9 @@
 {
   NS_LOG_FUNCTION (this << txVector);
   uint64_t uid;
-  if (txVector.GetPreambleType () == WIFI_PREAMBLE_HE_TB)
+  if (txVector.IsUlMu ())
     {
+      NS_ASSERT (txVector.GetModulationClass () == WIFI_MOD_CLASS_HE);
       //Use UID of PPDU containing trigger frame to identify resulting HE TB PPDUs, since the latter should immediately follow the former
       uid = m_wifiPhy->GetPreviouslyRxPpduUid ();
       NS_ASSERT (uid != UINT64_MAX);
@@ -870,7 +896,7 @@
 HePhy::GetCenterFrequencyForNonOfdmaPart (const WifiTxVector& txVector, uint16_t staId) const
 {
   NS_LOG_FUNCTION (this << txVector << staId);
-  NS_ASSERT (txVector.GetPreambleType () == WIFI_PREAMBLE_HE_TB);
+  NS_ASSERT (txVector.IsUlMu () && (txVector.GetModulationClass () == WIFI_MOD_CLASS_HE));
   uint16_t centerFrequency = GetCenterFrequencyForChannelWidth (txVector);
   uint16_t currentWidth = txVector.GetChannelWidth ();
 
@@ -914,16 +940,18 @@
 Time
 HePhy::CalculateTxDuration (WifiConstPsduMap psduMap, const WifiTxVector& txVector, WifiPhyBand band) const
 {
-  if (txVector.GetPreambleType () == WIFI_PREAMBLE_HE_TB)
+  if (txVector.IsUlMu ())
     {
+      NS_ASSERT (txVector.GetModulationClass () == WIFI_MOD_CLASS_HE);
       return ConvertLSigLengthToHeTbPpduDuration (txVector.GetLength (), txVector, band);
     }
 
   Time maxDuration = Seconds (0);
   for (auto & staIdPsdu : psduMap)
     {
-      if (txVector.GetPreambleType () == WIFI_PREAMBLE_HE_MU)
+      if (txVector.IsDlMu ())
         {
+          NS_ASSERT (txVector.GetModulationClass () == WIFI_MOD_CLASS_HE);
           WifiTxVector::HeMuUserInfoMap userInfoMap = txVector.GetHeMuUserInfoMap ();
           NS_ABORT_MSG_IF (userInfoMap.find (staIdPsdu.first) == userInfoMap.end (), "STA-ID in psduMap (" << staIdPsdu.first << ") should be referenced in txVector");
         }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/he/he-phy.h ns-3.35/src/wifi/model/he/he-phy.h
--- ns-3.34/src/wifi/model/he/he-phy.h	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/he/he-phy.h	2021-10-01 13:26:48.000000000 -0700
@@ -94,7 +94,7 @@
                            Time ppduDuration) override;
   Ptr<const WifiPsdu> GetAddressedPsduInPpdu (Ptr<const WifiPpdu> ppdu) const override;
   void StartReceivePreamble (Ptr<WifiPpdu> ppdu,
-                             RxPowerWattPerChannelBand rxPowersW,
+                             RxPowerWattPerChannelBand& rxPowersW,
                              Time rxDuration) override;
   void CancelAllEvents (void) override;
   uint16_t GetStaId (const Ptr<const WifiPpdu> ppdu) const override;
@@ -370,7 +370,7 @@
 protected:
   PhyFieldRxStatus ProcessSigA (Ptr<Event> event, PhyFieldRxStatus status) override;
   PhyFieldRxStatus ProcessSigB (Ptr<Event> event, PhyFieldRxStatus status) override;
-  Ptr<Event> DoGetEvent (Ptr<const WifiPpdu> ppdu, RxPowerWattPerChannelBand rxPowersW) override;
+  Ptr<Event> DoGetEvent (Ptr<const WifiPpdu> ppdu, RxPowerWattPerChannelBand& rxPowersW) override;
   bool IsConfigSupported (Ptr<const WifiPpdu> ppdu) const override;
   void DoStartReceivePayload (Ptr<Event> event) override;
   std::pair<uint16_t, WifiSpectrumBand> GetChannelWidthAndBand (const WifiTxVector& txVector, uint16_t staId) const override;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/he/he-ppdu.cc ns-3.35/src/wifi/model/he/he-ppdu.cc
--- ns-3.34/src/wifi/model/he/he-ppdu.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/he/he-ppdu.cc	2021-10-01 13:26:48.000000000 -0700
@@ -256,7 +256,7 @@
 {
   NS_LOG_FUNCTION (this << txCenterFreq << p20MinFreq << p20MaxFreq);
 
-  if (GetTxVector ().IsUlMu ())
+  if (IsUlMu ())
     {
       // APs are able to receive TB PPDUs sent on a band other than the primary20 channel
       return true;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/he/mu-edca-parameter-set.cc ns-3.35/src/wifi/model/he/mu-edca-parameter-set.cc
--- ns-3.34/src/wifi/model/he/mu-edca-parameter-set.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.35/src/wifi/model/he/mu-edca-parameter-set.cc	2021-10-01 13:26:48.000000000 -0700
@@ -0,0 +1,207 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2021 Universita' degli Studi di Napoli Federico II
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Stefano Avallone <stavallo@unina.it>
+ */
+
+#include "mu-edca-parameter-set.h"
+#include <cmath>
+#include <algorithm>
+
+namespace ns3 {
+
+MuEdcaParameterSet::MuEdcaParameterSet ()
+  : m_qosInfo (0),
+    m_records {{{0, 0, 0}, {0, 0, 0}, {0, 0, 0}, {0, 0, 0}}}
+{
+}
+
+WifiInformationElementId
+MuEdcaParameterSet::ElementId () const
+{
+  return IE_EXTENSION;
+}
+
+WifiInformationElementId
+MuEdcaParameterSet::ElementIdExt () const
+{
+  return IE_EXT_MU_EDCA_PARAMETER_SET;
+}
+
+bool
+MuEdcaParameterSet::IsPresent (void) const
+{
+  auto timerNotNull = [](const ParameterRecord &r) { return r.muEdcaTimer != 0; };
+
+  bool isPresent = std::all_of (m_records.begin (), m_records.end (), timerNotNull);
+  if (isPresent)
+    {
+      return true;
+    }
+  NS_ABORT_MSG_IF (std::any_of (m_records.begin (), m_records.end (), timerNotNull),
+                   "MU EDCA Timers must be either all zero or all non-zero.");
+  return false;
+}
+
+void
+MuEdcaParameterSet::SetQosInfo (uint8_t qosInfo)
+{
+  m_qosInfo = qosInfo;
+}
+
+void
+MuEdcaParameterSet::SetMuAifsn (uint8_t aci, uint8_t aifsn)
+{
+  NS_ABORT_MSG_IF (aci > 3, "Invalid AC Index value: " << +aci);
+  NS_ABORT_MSG_IF (aifsn == 1 || aifsn > 15, "Invalid AIFSN value: " << +aifsn);
+
+  m_records[aci].aifsnField |= (aifsn & 0x0f);
+  m_records[aci].aifsnField |= (aci & 0x03) << 5;
+}
+
+void
+MuEdcaParameterSet::SetMuCwMin (uint8_t aci, uint16_t cwMin)
+{
+  NS_ABORT_MSG_IF (aci > 3, "Invalid AC Index value: " << +aci);
+  NS_ABORT_MSG_IF (cwMin > 32767, "CWmin exceeds the maximum value");
+
+  auto eCwMin = std::log2 (cwMin + 1);
+  NS_ABORT_MSG_IF (std::trunc (eCwMin) != eCwMin, "CWmin is not a power of 2 minus 1");
+
+  m_records[aci].cwMinMax |= (static_cast<uint8_t> (eCwMin) & 0x0f);
+}
+
+void
+MuEdcaParameterSet::SetMuCwMax (uint8_t aci, uint16_t cwMax)
+{
+  NS_ABORT_MSG_IF (aci > 3, "Invalid AC Index value: " << +aci);
+  NS_ABORT_MSG_IF (cwMax > 32767, "CWmin exceeds the maximum value");
+
+  auto eCwMax = std::log2 (cwMax + 1);
+  NS_ABORT_MSG_IF (std::trunc (eCwMax) != eCwMax, "CWmax is not a power of 2 minus 1");
+
+  m_records[aci].cwMinMax |= (static_cast<uint8_t> (eCwMax) & 0x0f) << 4;
+}
+
+void
+MuEdcaParameterSet::SetMuEdcaTimer (uint8_t aci, Time timer)
+{
+  NS_ABORT_MSG_IF (aci > 3, "Invalid AC Index value: " << +aci);
+  NS_ABORT_MSG_IF (timer.IsStrictlyPositive () && timer < MicroSeconds (8192),
+                   "Timer value is below 8.192 ms");
+  NS_ABORT_MSG_IF (timer > MicroSeconds (2088960), "Timer value is above 2088.96 ms");
+
+  double value = timer.GetMicroSeconds () / 8192.;
+  NS_ABORT_MSG_IF (std::trunc (value) != value, "Timer value is not a multiple of 8 TUs (8192 us)");
+
+  m_records[aci].muEdcaTimer = static_cast<uint8_t> (value);
+}
+
+uint8_t
+MuEdcaParameterSet::GetQosInfo (void) const
+{
+  return m_qosInfo;
+}
+
+uint8_t
+MuEdcaParameterSet::GetMuAifsn (uint8_t aci) const
+{
+  NS_ABORT_MSG_IF (aci > 3, "Invalid AC Index value: " << +aci);
+  return (m_records[aci].aifsnField & 0x0f);
+}
+
+uint16_t
+MuEdcaParameterSet::GetMuCwMin (uint8_t aci) const
+{
+  NS_ABORT_MSG_IF (aci > 3, "Invalid AC Index value: " << +aci);
+  uint8_t eCwMin = (m_records[aci].cwMinMax & 0x0f);
+  return static_cast<uint16_t> (std::exp2 (eCwMin) - 1);
+}
+
+uint16_t
+MuEdcaParameterSet::GetMuCwMax (uint8_t aci) const
+{
+  NS_ABORT_MSG_IF (aci > 3, "Invalid AC Index value: " << +aci);
+  uint8_t eCwMax = ((m_records[aci].cwMinMax >> 4) & 0x0f);
+  return static_cast<uint16_t> (std::exp2 (eCwMax) - 1);
+}
+
+Time
+MuEdcaParameterSet::GetMuEdcaTimer (uint8_t aci) const
+{
+  NS_ABORT_MSG_IF (aci > 3, "Invalid AC Index value: " << +aci);
+  return MicroSeconds (m_records[aci].muEdcaTimer * 8192);
+}
+
+uint8_t
+MuEdcaParameterSet::GetInformationFieldSize () const
+{
+  NS_ASSERT (IsPresent ());
+  // ElementIdExt (1) + QoS Info (1) + MU Parameter Records (4 * 3)
+  return 14;
+}
+
+Buffer::Iterator
+MuEdcaParameterSet::Serialize (Buffer::Iterator i) const
+{
+  if (!IsPresent ())
+    {
+      return i;
+    }
+  return WifiInformationElement::Serialize (i);
+}
+
+uint16_t
+MuEdcaParameterSet::GetSerializedSize () const
+{
+  if (!IsPresent ())
+    {
+      return 0;
+    }
+  return WifiInformationElement::GetSerializedSize ();
+}
+
+void
+MuEdcaParameterSet::SerializeInformationField (Buffer::Iterator start) const
+{
+  if (IsPresent ())
+    {
+      start.WriteU8 (GetQosInfo ());
+      for (const auto& record : m_records)
+        {
+          start.WriteU8 (record.aifsnField);
+          start.WriteU8 (record.cwMinMax);
+          start.WriteU8 (record.muEdcaTimer);
+        }
+    }
+}
+
+uint8_t
+MuEdcaParameterSet::DeserializeInformationField (Buffer::Iterator start, uint8_t length)
+{
+  Buffer::Iterator i = start;
+  m_qosInfo = i.ReadU8 ();
+  for (auto& record : m_records)
+    {
+      record.aifsnField = i.ReadU8 ();
+      record.cwMinMax = i.ReadU8 ();
+      record.muEdcaTimer = i.ReadU8 ();
+    }
+  return 13;
+}
+
+} //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/he/mu-edca-parameter-set.h ns-3.35/src/wifi/model/he/mu-edca-parameter-set.h
--- ns-3.34/src/wifi/model/he/mu-edca-parameter-set.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.35/src/wifi/model/he/mu-edca-parameter-set.h	2021-10-01 13:26:48.000000000 -0700
@@ -0,0 +1,195 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2021 Universita' degli Studi di Napoli Federico II
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Stefano Avallone <stavallo@unina.it>
+ */
+
+#ifndef MU_EDCA_PARAMETER_SET_H
+#define MU_EDCA_PARAMETER_SET_H
+
+#include "ns3/wifi-information-element.h"
+#include "ns3/nstime.h"
+#include <array>
+
+namespace ns3 {
+
+/**
+ * \brief The MU EDCA Parameter Set
+ * \ingroup wifi
+ *
+ * The 802.11ax MU EDCA Parameter Set.
+ */
+class MuEdcaParameterSet : public WifiInformationElement
+{
+public:
+  MuEdcaParameterSet ();
+  /**
+   * Return true if a valid MU EDCA Parameter Set is present in this object
+   * \return true if a valid MU EDCA Parameter Set is present in this object
+   */
+  bool IsPresent (void) const;
+
+  /**
+   * Set the QoS Info field in the MuEdcaParameterSet information element.
+   *
+   * \param qosInfo the QoS Info field in the MuEdcaParameterSet information element
+   */
+  void SetQosInfo (uint8_t qosInfo);
+  /**
+   * Set the AIFSN subfield of the ACI/AIFSN field in the MU AC Parameter Record
+   * field corresponding to the given AC Index (<i>aci</i>). Note that <i>aifsn</i>
+   * can either be zero (EDCA disabled) or in the range from 2 to 15.
+   *
+   * \param aci the AC Index
+   * \param aifsn the value for the AIFSN subfield
+   */
+  void SetMuAifsn (uint8_t aci, uint8_t aifsn);
+  /**
+   * Set the ECWmin subfield of the ECWmin/ECWmax field in the MU AC Parameter Record
+   * field corresponding to the given AC Index (<i>aci</i>). Note that <i>cwMin</i>
+   * must be a power of 2 minus 1 in the range from 0 to 32767.
+   *
+   * \param aci the AC Index
+   * \param cwMin the CWmin value encoded by the ECWmin field
+   */
+  void SetMuCwMin (uint8_t aci, uint16_t cwMin);
+  /**
+   * Set the ECWmax subfield of the ECWmin/ECWmax field in the MU AC Parameter Record
+   * field corresponding to the given AC Index (<i>aci</i>). Note that <i>cwMax</i>
+   * must be a power of 2 minus 1 in the range from 0 to 32767.
+   *
+   * \param aci the AC Index
+   * \param cwMax the CWmax value encoded by the ECWmax field
+   */
+  void SetMuCwMax (uint8_t aci, uint16_t cwMax);
+  /**
+   * Set the MU EDCA Timer field in the MU AC Parameter Record field corresponding
+   * to the given AC Index (<i>aci</i>). Note that <i>timer</i> must be an integer
+   * multiple of 8 TUs (i.e., 8 * 1024 = 8192 microseconds) in the range from
+   * 8.192 milliseconds to 2088.96 milliseconds. A value of 0 is used to indicate
+   * that the MU EDCA Parameter Set element must not be sent and therefore it is
+   * only allowed if the MU EDCA Timer is set to 0 for all ACs.
+   *
+   * \param aci the AC Index
+   * \param timer the value for the timer encoded by the MU EDCA Timer field
+   */
+  void SetMuEdcaTimer (uint8_t aci, Time timer);
+
+  /**
+   * Return the QoS Info field in the MuEdcaParameterSet information element.
+   *
+   * \return the QoS Info field in the MuEdcaParameterSet information element
+   */
+  uint8_t GetQosInfo (void) const;
+  /**
+   * Get the AIFSN subfield of the ACI/AIFSN field in the MU AC Parameter Record
+   * field corresponding to the given AC Index (<i>aci</i>).
+   *
+   * \param aci the AC Index
+   * \return the value of the AIFSN subfield
+   */
+  uint8_t GetMuAifsn (uint8_t aci) const;
+  /**
+   * Get the CWmin value encoded by the ECWmin subfield of the ECWmin/ECWmax field
+   * in the MU AC Parameter Record field corresponding to the given AC Index (<i>aci</i>).
+   *
+   * \param aci the AC Index
+   * \return the CWmin value
+   */
+  uint16_t GetMuCwMin (uint8_t aci) const;
+  /**
+   * Get the CWmax value encoded by the ECWmax subfield of the ECWmin/ECWmax field
+   * in the MU AC Parameter Record field corresponding to the given AC Index (<i>aci</i>).
+   *
+   * \param aci the AC Index
+   * \return the CWmax value
+   */
+  uint16_t GetMuCwMax (uint8_t aci) const;
+  /**
+   * Get the MU EDCA Timer value encoded in the MU AC Parameter Record field corresponding
+   * to the given AC Index (<i>aci</i>).
+   *
+   * \param aci the AC Index
+   * \return the MU EDCA Timer value
+   */
+  Time GetMuEdcaTimer (uint8_t aci) const;
+
+  /**
+   * Get the wifi information element ID
+   * \return the wifi information element ID
+   */
+  WifiInformationElementId ElementId () const;
+  /**
+   * Get the wifi information element ID extension
+   * \return the wifi information element ID extension
+   */
+  WifiInformationElementId ElementIdExt () const;
+  /**
+   * Get information field size function
+   * \return the information field size
+   */
+  uint8_t GetInformationFieldSize () const;
+  /**
+   * Serialize information field function
+   * \param start the iterator
+   */
+  void SerializeInformationField (Buffer::Iterator start) const;
+  /**
+   * Deserialize information field function
+   * \param start the iterator
+   * \param length the length
+   * \return the size
+   */
+  uint8_t DeserializeInformationField (Buffer::Iterator start, uint8_t length);
+
+  /**
+   * This information element is a bit special in that it is only
+   * included if the STA is an HE STA. To support this we
+   * override the Serialize and GetSerializedSize methods of
+   * WifiInformationElement.
+   *
+   * \param start iterator start
+   *
+   * \return an iterator
+   */
+  Buffer::Iterator Serialize (Buffer::Iterator start) const;
+  /**
+   * Return the serialized size of this EDCA Parameter Set.
+   *
+   * \return the serialized size of this EDCA Parameter Set
+   */
+  uint16_t GetSerializedSize () const;
+
+
+private:
+  /**
+   * MU AC Parameter Record type
+   */
+  struct ParameterRecord
+    {
+      uint8_t aifsnField;                    ///< the ACI/AIFSN field
+      uint8_t cwMinMax;                      ///< the ECWmin/ECWmax field
+      uint8_t muEdcaTimer;                   ///< the MU EDCA Timer field
+    };
+
+  uint8_t m_qosInfo;                         ///< QoS info field
+  std::array<ParameterRecord, 4> m_records;  ///< MU AC Parameter Record fields
+};
+
+} //namespace ns3
+
+#endif /* MU_EDCA_PARAMETER_SET_H */
